//----------------------------------------------------------------------------------
// Types and Structures Definition
//----------------------------------------------------------------------------------


typedef struct Paratrooper
{
   int life;
   bool droped;
   Rectangle hitbox;
   Vector2 speed;
   Color color; // yellow or red
}Paratrooper;

typedef struct Aircraft
{
   int life;
   float xFirstToJump;
   int numberOfParatroopers;
   Rectangle hitbox;
   Vector2 speed;
   Color color; //black
}Aircraft;

typedef struct Bombshell
{
  float radius;
  float sin;
  float cos;
  bool ammoShot;
  Vector2 position;
  Vector2 speed;
  Color color;
}Bombshell;

typedef struct Bullet
{
  float radius;
  int damageDone;
  float sin;
  float cos;
  bool ammoShot;
  Vector2 position;
  Vector2 speed;
  Color color;
}Bullet;

typedef struct AntiAircraftCanon
{
    float sin;
    float cos;
    Vector2 position;
    Vector2 aimingPosition;
}AntiAircraftCanon;

typedef struct AntiParaCanon
{
    float sin;
    float cos;
    Vector2 position;
    Vector2 aimingPosition;
}AntiParaCanon;


//------------------------------------------------------------------------------------
// Module Functions Declaration 
//------------------------------------------------------------------------------------
static void InitGame(void);         // Initialize game
static void UpdateGame();       // Update game (one frame)
static void DrawGame(void);         // Draw game (one frame)
static void UnloadGame(void);       // Unload game

//------------------------------------------------------------------------------------
// Other Functions
//------------------------------------------------------------------------------------

//Initialization functions------------------------------------------------------------
Aircraft InitializeAircraft(void);
Bombshell InitializeBombshell(void);
Bullet InitializeBullet(void);
Paratrooper InitializeParatrooper(void);

//Game functions----------------------------------------------------------------------
bool IsRectangleOut(Rectangle rec);
bool IsCircleOut(Vector2 center, float radius);

